<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.6"/>
<title>LibArch: src/lib_memmgt.h Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">LibArch
   </div>
   <div id="projectbrief">Library architecture and framework</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.6 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../annotated.html"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../files.html"><span>File&#160;List</span></a></li>
      <li><a href="../../globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Macros</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="../../dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">lib_memmgt.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../db/d68/lib__memmgt_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/******************************************************************************</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright (c) 2015, Texas Instruments Incorporated - http://www.ti.com</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *   All rights reserved.</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *   Redistribution and use in source and binary forms, with or without</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> *   modification, are permitted provided that the following conditions are met:</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *       * Redistributions of source code must retain the above copyright</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *         notice, this list of conditions and the following disclaimer.</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *       * Redistributions in binary form must reproduce the above copyright</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *         notice, this list of conditions and the following disclaimer in the</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> *         documentation and/or other materials provided with the distribution.</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *       * Neither the name of Texas Instruments Incorporated nor the</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *         names of its contributors may be used to endorse or promote products</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *         derived from this software without specific prior written permission.</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> *   THE POSSIBILITY OF SUCH DAMAGE.</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> *****************************************************************************/</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#ifndef _LIBARCH_MEMMGT_H</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor"></span><span class="preprocessor">#define _LIBARCH_MEMMGT_H</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &lt;stdlib.h&gt;</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div>
<div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="../../d7/da6/group__libarch__memmgt.html#gacfa30c2c1e697da904265b91b9c60d2f">   43</a></span>&#160;<span class="preprocessor">#define LIB_MEMMGT_SUCCESS          (0)   </span></div>
<div class="line"><a name="l00044"></a><span class="lineno"><a class="line" href="../../d7/da6/group__libarch__memmgt.html#ga21728661e7141fcfd212ca8286a7947b">   44</a></span>&#160;<span class="preprocessor">#define LIB_MEMMGT_ERROR            (-1)  </span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="preprocessor">enum {</span></div>
<div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="../../d7/da6/group__libarch__memmgt.html#gga06fc87d81c62e9abb8790b6e5713c55ba98a90dd78f7e0d087e7d9c66505011c7">   53</a></span>&#160;<span class="preprocessor"></span>    <a class="code" href="../../d7/da6/group__libarch__memmgt.html#gga06fc87d81c62e9abb8790b6e5713c55ba98a90dd78f7e0d087e7d9c66505011c7">LIB_SMEM_VFAST</a> = 0, </div>
<div class="line"><a name="l00054"></a><span class="lineno"><a class="line" href="../../d7/da6/group__libarch__memmgt.html#gga06fc87d81c62e9abb8790b6e5713c55ba0554f0354c84251e347c0ee79ffe046d">   54</a></span>&#160;    <a class="code" href="../../d7/da6/group__libarch__memmgt.html#gga06fc87d81c62e9abb8790b6e5713c55ba0554f0354c84251e347c0ee79ffe046d">LIB_SMEM_FAST</a>,      </div>
<div class="line"><a name="l00055"></a><span class="lineno"><a class="line" href="../../d7/da6/group__libarch__memmgt.html#gga06fc87d81c62e9abb8790b6e5713c55bab6e0c7570cd8f2ada826e36d607d8abb">   55</a></span>&#160;    <a class="code" href="../../d7/da6/group__libarch__memmgt.html#gga06fc87d81c62e9abb8790b6e5713c55bab6e0c7570cd8f2ada826e36d607d8abb">LIB_SMEM_MED</a>,       </div>
<div class="line"><a name="l00056"></a><span class="lineno"><a class="line" href="../../d7/da6/group__libarch__memmgt.html#gga06fc87d81c62e9abb8790b6e5713c55badc4290cb2bdcc915f3156f39ce3ea361">   56</a></span>&#160;    <a class="code" href="../../d7/da6/group__libarch__memmgt.html#gga06fc87d81c62e9abb8790b6e5713c55badc4290cb2bdcc915f3156f39ce3ea361">LIB_SMEM_SLOW</a>,      </div>
<div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="../../d7/da6/group__libarch__memmgt.html#gga06fc87d81c62e9abb8790b6e5713c55ba5e2798bb86ffcd081fbd1a7fad3571a2">   57</a></span>&#160;    <a class="code" href="../../d7/da6/group__libarch__memmgt.html#gga06fc87d81c62e9abb8790b6e5713c55ba5e2798bb86ffcd081fbd1a7fad3571a2">LIB_PMEM_MED</a>,       </div>
<div class="line"><a name="l00058"></a><span class="lineno"><a class="line" href="../../d7/da6/group__libarch__memmgt.html#gga06fc87d81c62e9abb8790b6e5713c55ba106f7b37f3b11574158123d265359eeb">   58</a></span>&#160;    <a class="code" href="../../d7/da6/group__libarch__memmgt.html#gga06fc87d81c62e9abb8790b6e5713c55ba106f7b37f3b11574158123d265359eeb">LIB_PMEM_SLOW</a>,      </div>
<div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="../../d7/da6/group__libarch__memmgt.html#gga06fc87d81c62e9abb8790b6e5713c55ba1cb4f966271cb92f79ba8229136f3a70">   59</a></span>&#160;    <a class="code" href="../../d7/da6/group__libarch__memmgt.html#gga06fc87d81c62e9abb8790b6e5713c55ba1cb4f966271cb92f79ba8229136f3a70">LIB_MEMTYPE_N</a>       </div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;};</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div>
<div class="line"><a name="l00083"></a><span class="lineno"><a class="line" href="../../da/dec/structlib__memdscr__str.html">   83</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span><a class="code" href="../../da/dec/structlib__memdscr__str.html">lib_memdscr_str</a> {</div>
<div class="line"><a name="l00084"></a><span class="lineno"><a class="line" href="../../da/dec/structlib__memdscr__str.html#a95021f2dac50fa28470ebcd4c9c8b14c">   84</a></span>&#160;  <span class="keywordtype">void</span>   *<a class="code" href="../../da/dec/structlib__memdscr__str.html#a95021f2dac50fa28470ebcd4c9c8b14c">base</a>;      </div>
<div class="line"><a name="l00085"></a><span class="lineno"><a class="line" href="../../da/dec/structlib__memdscr__str.html#a34437a2f1655d8adaedb8b6f99baf5d1">   85</a></span>&#160;  <span class="keywordtype">size_t</span>  <a class="code" href="../../da/dec/structlib__memdscr__str.html#a34437a2f1655d8adaedb8b6f99baf5d1">size</a>;      </div>
<div class="line"><a name="l00086"></a><span class="lineno"><a class="line" href="../../da/dec/structlib__memdscr__str.html#adf173931ba35fc1b2fa93b8911e2ca09">   86</a></span>&#160;  <span class="keywordtype">size_t</span>  <a class="code" href="../../da/dec/structlib__memdscr__str.html#adf173931ba35fc1b2fa93b8911e2ca09">used</a>;      </div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;} <a class="code" href="../../d7/da6/group__libarch__memmgt.html#ga933f44304562f9591104d57b7868ebc3">lib_memdscr_t</a>;</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="keywordtype">int</span> <a class="code" href="../../d7/da6/group__libarch__memmgt.html#gaeeb7c8294fcd4640e4eaf7a741397032">lib_smem_vinit</a>  (<span class="keywordtype">void</span> *handle, <span class="keywordtype">void</span> *base, <span class="keywordtype">size_t</span> size); </div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;<span class="keywordtype">int</span> <a class="code" href="../../d7/da6/group__libarch__memmgt.html#gadd591cf0185afae77c89e62a35af6395">lib_smem_finit</a>  (<span class="keywordtype">void</span> *handle, <span class="keywordtype">void</span> *base, <span class="keywordtype">size_t</span> size); </div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;<span class="keywordtype">int</span> <a class="code" href="../../d7/da6/group__libarch__memmgt.html#ga991a1c6d4b40f4b4750c7fd1f8aa73f6">lib_smem_minit</a>  (<span class="keywordtype">void</span> *handle, <span class="keywordtype">void</span> *base, <span class="keywordtype">size_t</span> size); </div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="keywordtype">int</span> <a class="code" href="../../d7/da6/group__libarch__memmgt.html#ga1dd9ae589bdfe68ced145885ea4c4789">lib_smem_sinit</a>  (<span class="keywordtype">void</span> *handle, <span class="keywordtype">void</span> *base, <span class="keywordtype">size_t</span> size); </div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;<span class="keywordtype">void</span> *<a class="code" href="../../d7/da6/group__libarch__memmgt.html#ga24093174e441c683650863236dcb9806">lib_smem_valloc</a> (<span class="keywordtype">void</span> *handle, <span class="keywordtype">size_t</span> size, <span class="keywordtype">size_t</span> align);</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;<span class="keywordtype">void</span> *<a class="code" href="../../d7/da6/group__libarch__memmgt.html#ga51d763b1f89ef58e83cb9e4bc7546ba8">lib_smem_falloc</a> (<span class="keywordtype">void</span> *handle, <span class="keywordtype">size_t</span> size, <span class="keywordtype">size_t</span> align);</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;<span class="keywordtype">void</span> *<a class="code" href="../../d7/da6/group__libarch__memmgt.html#gaac0047f2fe5ce1dfad45fc0333d906dc">lib_smem_malloc</a> (<span class="keywordtype">void</span> *handle, <span class="keywordtype">size_t</span> size, <span class="keywordtype">size_t</span> align);</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;<span class="keywordtype">void</span> *<a class="code" href="../../d7/da6/group__libarch__memmgt.html#ga08b73e8bf61fb50e20e08f7df4de636b">lib_smem_salloc</a> (<span class="keywordtype">void</span> *handle, <span class="keywordtype">size_t</span> size, <span class="keywordtype">size_t</span> align);</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;<span class="keywordtype">int</span> <a class="code" href="../../d7/da6/group__libarch__memmgt.html#ga65c30f7a20c6e359df9d73db0c9078c1">lib_smem_vreset</a> (<span class="keywordtype">void</span> *handle);</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;<span class="keywordtype">int</span> <a class="code" href="../../d7/da6/group__libarch__memmgt.html#ga18470bba549f0d9c4a6d98a1f615b8c2">lib_smem_freset</a> (<span class="keywordtype">void</span> *handle);</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;<span class="keywordtype">int</span> <a class="code" href="../../d7/da6/group__libarch__memmgt.html#ga38dbf46a5af66e691ba20ffb61f9932e">lib_smem_mreset</a> (<span class="keywordtype">void</span> *handle);</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;</div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;<span class="keywordtype">int</span> <a class="code" href="../../d7/da6/group__libarch__memmgt.html#gaa3fb30e824c80ec62d4e7847f292108f">lib_smem_sreset</a> (<span class="keywordtype">void</span> *handle);</div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;</div>
<div class="line"><a name="l00307"></a><span class="lineno"><a class="line" href="../../d7/da6/group__libarch__memmgt.html#gaeae499cb566d6411b938107d3ffeb144">  307</a></span>&#160;<span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> *<a class="code" href="../../d7/da6/group__libarch__memmgt.html#gaeae499cb566d6411b938107d3ffeb144">lib_pmem_malloc</a> (<span class="keywordtype">void</span> *handle, <span class="keywordtype">size_t</span> size, <span class="keywordtype">size_t</span> align)</div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;{</div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;    <span class="keywordflow">return</span>(memalign(align, size));</div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;}</div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;</div>
<div class="line"><a name="l00331"></a><span class="lineno"><a class="line" href="../../d7/da6/group__libarch__memmgt.html#ga306a1aa220281f0b6d79b12928bfeff8">  331</a></span>&#160;<span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> *<a class="code" href="../../d7/da6/group__libarch__memmgt.html#ga306a1aa220281f0b6d79b12928bfeff8">lib_pmem_salloc</a> (<span class="keywordtype">void</span> *handle, <span class="keywordtype">size_t</span> size, <span class="keywordtype">size_t</span> align)</div>
<div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;{</div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;    <span class="keywordflow">return</span>(memalign(align, size));</div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;}</div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;</div>
<div class="line"><a name="l00348"></a><span class="lineno"><a class="line" href="../../d7/da6/group__libarch__memmgt.html#gafeda2ec3f28d9ebb87a8adcecbb0f414">  348</a></span>&#160;<span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="../../d7/da6/group__libarch__memmgt.html#gafeda2ec3f28d9ebb87a8adcecbb0f414">lib_pmem_mfree</a> (<span class="keywordtype">void</span> *handle, <span class="keywordtype">void</span> *mem_ptr)</div>
<div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;{</div>
<div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;  free(mem_ptr);</div>
<div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;}</div>
<div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;</div>
<div class="line"><a name="l00365"></a><span class="lineno"><a class="line" href="../../d7/da6/group__libarch__memmgt.html#gab12e1d41b3d71633c9ab2d8818510f63">  365</a></span>&#160;<span class="keyword">static</span> <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="../../d7/da6/group__libarch__memmgt.html#gab12e1d41b3d71633c9ab2d8818510f63">lib_pmem_sfree</a> (<span class="keywordtype">void</span> *handle, <span class="keywordtype">void</span> *mem_ptr)</div>
<div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;{</div>
<div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;  free(mem_ptr);</div>
<div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;}</div>
<div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;</div>
<div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;<span class="preprocessor">#endif  </span><span class="comment">/* _LIBARCH_MEMMGT_H */</span><span class="preprocessor"></span></div>
<div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;<span class="comment">/* nothing past this point */</span></div>
<div class="ttc" id="group__libarch__memmgt_html_gga06fc87d81c62e9abb8790b6e5713c55badc4290cb2bdcc915f3156f39ce3ea361"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#gga06fc87d81c62e9abb8790b6e5713c55badc4290cb2bdcc915f3156f39ce3ea361">LIB_SMEM_SLOW</a></div><div class="ttdef"><b>Definition:</b> lib_memmgt.h:56</div></div>
<div class="ttc" id="group__libarch__memmgt_html_ga38dbf46a5af66e691ba20ffb61f9932e"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#ga38dbf46a5af66e691ba20ffb61f9932e">lib_smem_mreset</a></div><div class="ttdeci">int lib_smem_mreset(void *handle)</div><div class="ttdoc">Function lib_smem_mreset resets the medium speed scratch heap and destroys all allocated memory block...</div><div class="ttdef"><b>Definition:</b> lib_memmgt.c:210</div></div>
<div class="ttc" id="group__libarch__memmgt_html_ga306a1aa220281f0b6d79b12928bfeff8"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#ga306a1aa220281f0b6d79b12928bfeff8">lib_pmem_salloc</a></div><div class="ttdeci">static void * lib_pmem_salloc(void *handle, size_t size, size_t align)</div><div class="ttdoc">Function lib_pmem_salloc allocates a memory block from the slow permanent heap. It will also align th...</div><div class="ttdef"><b>Definition:</b> lib_memmgt.h:331</div></div>
<div class="ttc" id="group__libarch__memmgt_html_gga06fc87d81c62e9abb8790b6e5713c55bab6e0c7570cd8f2ada826e36d607d8abb"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#gga06fc87d81c62e9abb8790b6e5713c55bab6e0c7570cd8f2ada826e36d607d8abb">LIB_SMEM_MED</a></div><div class="ttdef"><b>Definition:</b> lib_memmgt.h:55</div></div>
<div class="ttc" id="group__libarch__memmgt_html_ga51d763b1f89ef58e83cb9e4bc7546ba8"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#ga51d763b1f89ef58e83cb9e4bc7546ba8">lib_smem_falloc</a></div><div class="ttdeci">void * lib_smem_falloc(void *handle, size_t size, size_t align)</div><div class="ttdoc">Function lib_smem_falloc allocates a memory block from the fast scratch heap. It will also align the ...</div><div class="ttdef"><b>Definition:</b> lib_memmgt.c:170</div></div>
<div class="ttc" id="group__libarch__memmgt_html_ga1dd9ae589bdfe68ced145885ea4c4789"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#ga1dd9ae589bdfe68ced145885ea4c4789">lib_smem_sinit</a></div><div class="ttdeci">int lib_smem_sinit(void *handle, void *base, size_t size)</div><div class="ttdoc">Function lib_smem_sinit performs necessary initialization for the slow scratch heap memory allocation...</div><div class="ttdef"><b>Definition:</b> lib_memmgt.c:154</div></div>
<div class="ttc" id="structlib__memdscr__str_html"><div class="ttname"><a href="../../da/dec/structlib__memdscr__str.html">lib_memdscr_str</a></div><div class="ttdoc">Memory descriptor structure. </div><div class="ttdef"><b>Definition:</b> lib_memmgt.h:83</div></div>
<div class="ttc" id="structlib__memdscr__str_html_a95021f2dac50fa28470ebcd4c9c8b14c"><div class="ttname"><a href="../../da/dec/structlib__memdscr__str.html#a95021f2dac50fa28470ebcd4c9c8b14c">lib_memdscr_str::base</a></div><div class="ttdeci">void * base</div><div class="ttdef"><b>Definition:</b> lib_memmgt.h:84</div></div>
<div class="ttc" id="group__libarch__memmgt_html_ga18470bba549f0d9c4a6d98a1f615b8c2"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#ga18470bba549f0d9c4a6d98a1f615b8c2">lib_smem_freset</a></div><div class="ttdeci">int lib_smem_freset(void *handle)</div><div class="ttdoc">Function lib_smem_freset resets the fast scratch heap and destroys all allocated memory blocks in it...</div><div class="ttdef"><b>Definition:</b> lib_memmgt.c:202</div></div>
<div class="ttc" id="group__libarch__memmgt_html_gafeda2ec3f28d9ebb87a8adcecbb0f414"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#gafeda2ec3f28d9ebb87a8adcecbb0f414">lib_pmem_mfree</a></div><div class="ttdeci">static void lib_pmem_mfree(void *handle, void *mem_ptr)</div><div class="ttdoc">Refer to lib_memmgt.h for detailed documentation. </div><div class="ttdef"><b>Definition:</b> lib_memmgt.h:348</div></div>
<div class="ttc" id="group__libarch__memmgt_html_gga06fc87d81c62e9abb8790b6e5713c55ba98a90dd78f7e0d087e7d9c66505011c7"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#gga06fc87d81c62e9abb8790b6e5713c55ba98a90dd78f7e0d087e7d9c66505011c7">LIB_SMEM_VFAST</a></div><div class="ttdef"><b>Definition:</b> lib_memmgt.h:53</div></div>
<div class="ttc" id="group__libarch__memmgt_html_ga08b73e8bf61fb50e20e08f7df4de636b"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#ga08b73e8bf61fb50e20e08f7df4de636b">lib_smem_salloc</a></div><div class="ttdeci">void * lib_smem_salloc(void *handle, size_t size, size_t align)</div><div class="ttdoc">Function lib_smem_salloc allocates a memory block from the slow scratch heap. It will also align the ...</div><div class="ttdef"><b>Definition:</b> lib_memmgt.c:186</div></div>
<div class="ttc" id="group__libarch__memmgt_html_ga24093174e441c683650863236dcb9806"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#ga24093174e441c683650863236dcb9806">lib_smem_valloc</a></div><div class="ttdeci">void * lib_smem_valloc(void *handle, size_t size, size_t align)</div><div class="ttdoc">Function lib_smem_valloc allocates a memory block from the very fast scratch heap. It will also align the allocated memory block as requested. </div><div class="ttdef"><b>Definition:</b> lib_memmgt.c:162</div></div>
<div class="ttc" id="group__libarch__memmgt_html_gaeae499cb566d6411b938107d3ffeb144"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#gaeae499cb566d6411b938107d3ffeb144">lib_pmem_malloc</a></div><div class="ttdeci">static void * lib_pmem_malloc(void *handle, size_t size, size_t align)</div><div class="ttdoc">Function lib_pmem_malloc allocates a memory block from the medium speed permanent heap...</div><div class="ttdef"><b>Definition:</b> lib_memmgt.h:307</div></div>
<div class="ttc" id="group__libarch__memmgt_html_ga991a1c6d4b40f4b4750c7fd1f8aa73f6"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#ga991a1c6d4b40f4b4750c7fd1f8aa73f6">lib_smem_minit</a></div><div class="ttdeci">int lib_smem_minit(void *handle, void *base, size_t size)</div><div class="ttdoc">Function lib_smem_minit performs necessary initialization for the medium speed scratch heap memory al...</div><div class="ttdef"><b>Definition:</b> lib_memmgt.c:146</div></div>
<div class="ttc" id="group__libarch__memmgt_html_gga06fc87d81c62e9abb8790b6e5713c55ba0554f0354c84251e347c0ee79ffe046d"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#gga06fc87d81c62e9abb8790b6e5713c55ba0554f0354c84251e347c0ee79ffe046d">LIB_SMEM_FAST</a></div><div class="ttdef"><b>Definition:</b> lib_memmgt.h:54</div></div>
<div class="ttc" id="group__libarch__memmgt_html_gadd591cf0185afae77c89e62a35af6395"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#gadd591cf0185afae77c89e62a35af6395">lib_smem_finit</a></div><div class="ttdeci">int lib_smem_finit(void *handle, void *base, size_t size)</div><div class="ttdoc">Function lib_smem_finit performs necessary initialization for the fast scratch heap memory allocation...</div><div class="ttdef"><b>Definition:</b> lib_memmgt.c:138</div></div>
<div class="ttc" id="group__libarch__memmgt_html_gga06fc87d81c62e9abb8790b6e5713c55ba106f7b37f3b11574158123d265359eeb"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#gga06fc87d81c62e9abb8790b6e5713c55ba106f7b37f3b11574158123d265359eeb">LIB_PMEM_SLOW</a></div><div class="ttdef"><b>Definition:</b> lib_memmgt.h:58</div></div>
<div class="ttc" id="group__libarch__memmgt_html_gab12e1d41b3d71633c9ab2d8818510f63"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#gab12e1d41b3d71633c9ab2d8818510f63">lib_pmem_sfree</a></div><div class="ttdeci">static void lib_pmem_sfree(void *handle, void *mem_ptr)</div><div class="ttdoc">Refer to lib_memmgt.h for detailed documentation. </div><div class="ttdef"><b>Definition:</b> lib_memmgt.h:365</div></div>
<div class="ttc" id="structlib__memdscr__str_html_a34437a2f1655d8adaedb8b6f99baf5d1"><div class="ttname"><a href="../../da/dec/structlib__memdscr__str.html#a34437a2f1655d8adaedb8b6f99baf5d1">lib_memdscr_str::size</a></div><div class="ttdeci">size_t size</div><div class="ttdef"><b>Definition:</b> lib_memmgt.h:85</div></div>
<div class="ttc" id="group__libarch__memmgt_html_gaa3fb30e824c80ec62d4e7847f292108f"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#gaa3fb30e824c80ec62d4e7847f292108f">lib_smem_sreset</a></div><div class="ttdeci">int lib_smem_sreset(void *handle)</div><div class="ttdoc">Function lib_smem_mreset resets the slow scratch heap and destroys all allocated memory blocks in it...</div><div class="ttdef"><b>Definition:</b> lib_memmgt.c:218</div></div>
<div class="ttc" id="group__libarch__memmgt_html_ga65c30f7a20c6e359df9d73db0c9078c1"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#ga65c30f7a20c6e359df9d73db0c9078c1">lib_smem_vreset</a></div><div class="ttdeci">int lib_smem_vreset(void *handle)</div><div class="ttdoc">Function lib_smem_vreset resets the very fast scratch heap and destroys all allocated memory blocks i...</div><div class="ttdef"><b>Definition:</b> lib_memmgt.c:194</div></div>
<div class="ttc" id="group__libarch__memmgt_html_gga06fc87d81c62e9abb8790b6e5713c55ba5e2798bb86ffcd081fbd1a7fad3571a2"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#gga06fc87d81c62e9abb8790b6e5713c55ba5e2798bb86ffcd081fbd1a7fad3571a2">LIB_PMEM_MED</a></div><div class="ttdef"><b>Definition:</b> lib_memmgt.h:57</div></div>
<div class="ttc" id="structlib__memdscr__str_html_adf173931ba35fc1b2fa93b8911e2ca09"><div class="ttname"><a href="../../da/dec/structlib__memdscr__str.html#adf173931ba35fc1b2fa93b8911e2ca09">lib_memdscr_str::used</a></div><div class="ttdeci">size_t used</div><div class="ttdef"><b>Definition:</b> lib_memmgt.h:86</div></div>
<div class="ttc" id="group__libarch__memmgt_html_ga933f44304562f9591104d57b7868ebc3"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#ga933f44304562f9591104d57b7868ebc3">lib_memdscr_t</a></div><div class="ttdeci">struct lib_memdscr_str lib_memdscr_t</div><div class="ttdoc">Memory descriptor structure. </div></div>
<div class="ttc" id="group__libarch__memmgt_html_gga06fc87d81c62e9abb8790b6e5713c55ba1cb4f966271cb92f79ba8229136f3a70"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#gga06fc87d81c62e9abb8790b6e5713c55ba1cb4f966271cb92f79ba8229136f3a70">LIB_MEMTYPE_N</a></div><div class="ttdef"><b>Definition:</b> lib_memmgt.h:59</div></div>
<div class="ttc" id="group__libarch__memmgt_html_gaeeb7c8294fcd4640e4eaf7a741397032"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#gaeeb7c8294fcd4640e4eaf7a741397032">lib_smem_vinit</a></div><div class="ttdeci">int lib_smem_vinit(void *handle, void *base, size_t size)</div><div class="ttdoc">Function lib_smem_vinit performs necessary initialization for the very fast scratch heap memory alloc...</div><div class="ttdef"><b>Definition:</b> lib_memmgt.c:130</div></div>
<div class="ttc" id="group__libarch__memmgt_html_gaac0047f2fe5ce1dfad45fc0333d906dc"><div class="ttname"><a href="../../d7/da6/group__libarch__memmgt.html#gaac0047f2fe5ce1dfad45fc0333d906dc">lib_smem_malloc</a></div><div class="ttdeci">void * lib_smem_malloc(void *handle, size_t size, size_t align)</div><div class="ttdoc">Function lib_smem_malloc allocates a memory block from the medium speed scratch heap. It will also align the address of the allocated memory block as requested. </div><div class="ttdef"><b>Definition:</b> lib_memmgt.c:178</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Mon Mar 6 2017 14:10:51 for LibArch by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="../../doxygen.png" alt="doxygen"/>
</a> 1.8.6
</small></address>
</body>
</html>
